unit main;
{-------------------------------------------------------------------------------
  ExtRes Creator V1.0
  Copyright 2003 Tumbleweeds ICT. All rights reserved 
--------------------------------------------------------------------------------
  This program is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published by the Free
  Software Foundation; either version 2 of the License, or (at your option)
  any later version.

  This program is distributed in the hope that it will be useful, but WITHOUT
  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
  FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
  more details.

  You should have received a copy of the GNU General Public License along
  with this program; if not, write to the Free Software Foundation, Inc.,
  59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
    
  Get the latest version of Extres at www.extres.org.
--------------------------------------------------------------------------------
  Author(s): Patrick van Kemenade
  Revision info :  09-10-2003  Created
-------------------------------------------------------------------------------}
{  implement import lines

}
interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Menus, Grids, ValEdit, ComCtrls, ExtCtrls, StdCtrls;

type
  TfrmMain = class(TForm)
    MainMenu1: TMainMenu;
    mnuFile: TMenuItem;
    mnuOption: TMenuItem;
    mnuHelp: TMenuItem;
    mnuOpen: TMenuItem;
    mnuNew: TMenuItem;
    mnuSave: TMenuItem;
    mnuExit: TMenuItem;
    OpenDialog: TOpenDialog;
    SaveDialog: TSaveDialog;
    StatusBar: TStatusBar;
    Panel1: TPanel;
    PopupValList: TPopupMenu;
    popupAdd: TMenuItem;
    popupDelete: TMenuItem;
    popupEdit: TMenuItem;
    GroupBoxEncr: TGroupBox;
    EditKey: TEdit;
    lblKey: TLabel;
    RadioButtonStandard: TRadioButton;
    RadioButtonUser: TRadioButton;
    ValueListEditor1: TValueListEditor;
    PopupFind: TMenuItem;
    mnuFind: TMenuItem;
    N2: TMenuItem;
    N3: TMenuItem;
    mnuCreateCheader: TMenuItem;
    mnuCreateDelphiUnit: TMenuItem;
    mnuSort: TMenuItem;
    mnuContents: TMenuItem;
    mnuAbout: TMenuItem;
    N1: TMenuItem;
    GroupBox1: TGroupBox;
    GroupBox2: TGroupBox;
    btnCreate: TButton;
    CheckBoxCompress: TCheckBox;
    procedure mnuExitClick(Sender: TObject);
    procedure mnuOpenClick(Sender: TObject);
    procedure mnuSaveClick(Sender: TObject);
    procedure RadioButtonUserClick(Sender: TObject);
    procedure mnuNewClick(Sender: TObject);
    procedure popupAddClick(Sender: TObject);
    procedure PopupValListPopup(Sender: TObject);
    procedure popupEditClick(Sender: TObject);
    procedure popupDeleteClick(Sender: TObject);
    procedure PopupFindClick(Sender: TObject);
    procedure ValueListEditor1DblClick(Sender: TObject);
    procedure mnuCreateCheaderClick(Sender: TObject);
    procedure mnuCreateDelphiUnitClick(Sender: TObject);
    procedure mnuOptionClick(Sender: TObject);
    procedure mnuSortClick(Sender: TObject);
    procedure btnCreateClick(Sender: TObject);
    procedure mnuAboutClick(Sender: TObject);
    procedure EditKeyExit(Sender: TObject);
    procedure mnuFileClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
    procedure ExportCDefs;
    procedure ExportPasDefs;
  public
    { Public declarations }
    CurrentFilename : string;
    function KeyUnique(key : string) : boolean;
    function LoadGrid(filename:string) : boolean;
    function SaveGrid(filename:string) : boolean;
  end;

var
  frmMain: TfrmMain;

implementation
uses dlgaddedit, dlgfindkey, dlgAbout, extres;
{$R *.dfm}

//-----------------------------------------------------------------------------
procedure TfrmMain.FormClose(Sender: TObject; var Action: TCloseAction);
begin
    mnuExitClick(Sender);
    Action := caFree;
end;


//-----------------------------------------------------------------------------
procedure TfrmMain.mnuFileClick(Sender: TObject);
begin
  mnuSave.Enabled := (ValueListEditor1.Strings.Count > 0);
end;

//-----------------------------------------------------------------------------
procedure TfrmMain.mnuNewClick(Sender: TObject);
begin
  if ValueListEditor1.Strings.count > 0 then
  begin
    if Application.MessageBox('Do you want to save your current resources?', 'Save current resources', MB_YESNO) = IDYES then
      mnuSaveClick(Sender);
    ValueListEditor1.Strings.Clear;
  end;
  OpenDialog.Title := 'New extres source file';
  OpenDialog.Options := OpenDialog.Options - [ofFileMustExist];
  if opendialog.execute then
     CurrentFilename := opendialog.filename;
  opendialog.Options := opendialog.Options + [ofFileMustExist];
  btnCreate.Enabled := (ValueListEditor1.Strings.count > 0);
end;

//-----------------------------------------------------------------------------
procedure TfrmMain.mnuOpenClick(Sender: TObject);
var
  Save_Cursor:TCursor;
begin
  if ValueListEditor1.Strings.count > 0 then
  begin
    if Application.MessageBox('Do you want to save your current resources?', 'Save current resources', MB_YESNO) = IDYES then
      mnuSaveClick(Sender);
    ValueListEditor1.Strings.Clear;
  end;
  OpenDialog.Title := 'Open extres source file';
  if opendialog.execute then
  begin
    CurrentFilename := opendialog.filename;
    Save_Cursor := Screen.Cursor;
    try
      Screen.Cursor := crHourGlass;    { Show hourglass cursor }
      LoadGrid(CurrentFilename);
    finally
      Screen.Cursor := Save_Cursor;  { Always restore to normal }
    end;
  end;
  btnCreate.Enabled := (ValueListEditor1.Strings.count > 0);
end;

//-----------------------------------------------------------------------------
procedure TfrmMain.mnuSaveClick(Sender: TObject);
var
  Save_Cursor:TCursor;
begin
  savedialog.filename := CurrentFilename;
  if savedialog.execute then
  begin
    CurrentFilename := savedialog.filename;
    Save_Cursor := Screen.Cursor;
    try
      Screen.Cursor := crHourGlass;    { Show hourglass cursor }
      SaveGrid(CurrentFilename);
    finally
      Screen.Cursor := Save_Cursor;  { Always restore to normal }
    end;
  end;
end;

//-----------------------------------------------------------------------------
procedure TfrmMain.mnuExitClick(Sender: TObject);
begin
  if ValueListEditor1.Strings.count > 0 then
  begin
    if Application.MessageBox('Do you want to save your current resources?', 'Save current resources', MB_YESNO) = IDYES then
      mnuSaveClick(Sender);
    ValueListEditor1.Strings.Clear;
  end;
  Application.Terminate;
end;

//-----------------------------------------------------------------------------
procedure TfrmMain.mnuOptionClick(Sender: TObject);
begin
  mnuFind.Enabled := (ValueListEditor1.Strings.count > 0);
  mnuSort.Enabled := (ValueListEditor1.Strings.count > 0);
end;

//-----------------------------------------------------------------------------
procedure TfrmMain.mnuSortClick(Sender: TObject);
var
  j, st, limit : integer;
  swapped : boolean;
  Save_Cursor:TCursor;
begin

  Save_Cursor := Screen.Cursor;
  try
    Screen.Cursor := crHourGlass;    { Show hourglass cursor }
    // fast bi_bubble_sort algorithm
    st := -1;
    limit := ValueListEditor1.Strings.Count-1;

    while st < limit do
    begin
      swapped := false;
      inc(st);
      dec(limit);
      for j := st to limit do
      begin
         if Uppercase(Copy(ValueListEditor1.Strings[j], 1, pos('=', ValueListEditor1.Strings[j])-1)) > Uppercase(Copy(ValueListEditor1.Strings[j+1], 1, pos('=', ValueListEditor1.Strings[j+1])-1))then
         begin
           ValueListEditor1.Strings.Move(j+1, j);
           swapped := true;
         end;
       end;
       if not swapped then                         // Quit if the array is already sorted
         exit;
       swapped := false;

      for j:=limit downto st do             // Bubble the next smallest one down
      begin
         if Uppercase(Copy(ValueListEditor1.Strings[j], 1, pos('=', ValueListEditor1.Strings[j])-1)) > Uppercase(Copy(ValueListEditor1.Strings[j+1], 1, pos('=', ValueListEditor1.Strings[j+1])-1))then
         begin
           ValueListEditor1.Strings.Move(j+1, j);
           swapped := true;
         end;
      end;
      if not swapped then                         // Quit if the array is already sorted
       exit;
    end;
  finally
    Screen.Cursor := Save_Cursor;  { Always restore to normal }
  end;

end;

//-----------------------------------------------------------------------------
procedure TfrmMain.mnuCreateCheaderClick(Sender: TObject);
begin
  MnuCreateCheader.Checked := not MnuCreateCheader.Checked;
end;

//-----------------------------------------------------------------------------
procedure TfrmMain.mnuCreateDelphiUnitClick(Sender: TObject);
begin
  MnuCreateDelphiUnit.Checked := not MnuCreateDelphiUnit.Checked;
end;

//-----------------------------------------------------------------------------
procedure TfrmMain.mnuAboutClick(Sender: TObject);
begin
  frmAbout.ShowModal;
end;

//-----------------------------------------------------------------------------
procedure TfrmMain.RadioButtonUserClick(Sender: TObject);
begin
  EditKey.Enabled  := RadioButtonUser.Checked;
  lblKey.Enabled  := RadioButtonUser.Checked;
  EditKey.Readonly := not RadioButtonUser.Checked;
  if EditKey.Enabled then
    EditKey.SetFocus;
end;

//-----------------------------------------------------------------------------
procedure TfrmMain.ValueListEditor1DblClick(Sender: TObject);
begin
   if(ValueListEditor1.Keys[ValueListEditor1.Row] <> '') and
     (ValueListEditor1.Values[ValueListEditor1.Keys[ValueListEditor1.Row]] <> '')then
     popupEditClick(Sender)
   else
     popupAddClick(Sender);
end;

//-----------------------------------------------------------------------------
procedure TfrmMain.popupAddClick(Sender: TObject);
begin
  AddEditDlg.Text := '';
  AddEditDlg.Key := '';
  AddEditDlg.editMode := false;
  if AddEditDlg.ShowModal = mrOk then
  begin
    try
      ValueListEditor1.InsertRow(AddEditDlg.Key, AddEditDlg.Text, true);
    except
     on exception do ;
    end;
  end;
  btnCreate.Enabled := (ValueListEditor1.Strings.count > 0);
end;

//-----------------------------------------------------------------------------
procedure TfrmMain.popupEditClick(Sender: TObject);
var
  lpStr : pChar;
begin
  AddEditDlg.Key := ValueListEditor1.Keys[ValueListEditor1.Row];
  lpStr := AllocMem(Length(ValueListEditor1.Values[ValueListEditor1.Keys[ValueListEditor1.Row]])+1);
  StrPCopy(lpStr, ValueListEditor1.Values[ValueListEditor1.Keys[ValueListEditor1.Row]]);
  _extResUnserialize(lpStr);
  AddEditDlg.Text := string(lpStr);
  FreeMem(lpStr);
  AddEditDlg.editMode := true;

  if AddEditDlg.ShowModal = mrOk then
  begin
    ValueListEditor1.DeleteRow(ValueListEditor1.Row);
    ValueListEditor1.InsertRow(AddEditDlg.Key, AddEditDlg.Text, false);
  end
end;

//-----------------------------------------------------------------------------
procedure TfrmMain.popupDeleteClick(Sender: TObject);
var
 rect : tGridRect;
 i : integer;
begin
  rect := ValueListEditor1.Selection;
  for i := rect.bottom downto rect.top do
  begin
    ValueListEditor1.DeleteRow(i);
  end;
  btnCreate.Enabled := (ValueListEditor1.Strings.count > 0);
end;

//-----------------------------------------------------------------------------
procedure TfrmMain.PopupFindClick(Sender: TObject);
var
  rowNr : integer;
  found : boolean;
begin
  if FindKeyDlg.ShowModal = mrOk then
  begin
    found := ValueListEditor1.FindRow(FindKeyDlg.key, rowNr);
    if not found then
      MessageDlg('Sorry, key not found.', mtInformation	, [mbOK]	, 0)
    else
    begin
      if ValueListEditor1.row = rowNr then
      begin
        if (rowNr < ValueListEditor1.RowCount-1) and (rowNr > 1) then
          ValueListEditor1.row := rowNr -1
        else if (rowNr = ValueListEditor1.RowCount-1) and (rowNr > 1) then
          ValueListEditor1.row := rowNr -1
        else if (rowNr = 1) and (ValueListEditor1.RowCount-1 > 1) then
          ValueListEditor1.row := rowNr +1;
      end;
      ValueListEditor1.refresh;
      ValueListEditor1.row := rowNr;
    end;
  end;

end;

//-----------------------------------------------------------------------------
procedure TfrmMain.PopupValListPopup(Sender: TObject);
var
 rect : tGridRect;
begin
  rect := ValueListEditor1.Selection;
  if(rect.Bottom - rect.Top) >= 1 then // multiple rows selected
    popupDelete.Caption := 'Delete selected rows'
  else
    popupDelete.Caption := 'Delete row';

  if ((rect.Bottom - rect.Top) = 0) and
    (ValueListEditor1.Keys[ValueListEditor1.Row] <> '') and
    (ValueListEditor1.Values[ValueListEditor1.Keys[ValueListEditor1.Row]] <> '')then
    popupEdit.Enabled := true
  else
    popupEdit.Enabled := false;
  popupDelete.Enabled := ((rect.Bottom - rect.Top) >= 1) or popupEdit.Enabled;
  popupFind.Enabled := (ValueListEditor1.Strings.count > 0);
end;

//-----------------------------------------------------------------------------
function TfrmMain.KeyUnique(key : string) : boolean;
var
  rowNr : integer;
begin
  result := not ValueListEditor1.FindRow(key, rowNr);
end;

//-----------------------------------------------------------------------------
function TfrmMain.LoadGrid(filename:string) : boolean;
var
  Fp : TextFile ;
  str : AnsiString;
  key : String;
  index : integer;
  noKey : string;
  noKeyIndex : integer;
begin
  noKey := 'KEY';
  noKeyIndex := 0;
  AssignFile(Fp, filename);
  Reset(Fp);
  while not Eof(Fp) do
  begin
    Readln(Fp, str);
    index := AnsiPos(',', str);
    Delete(str, 1,index);       // remove numeric value
    index := AnsiPos(',', str);
    key := Copy(str, 1,index-1);
    Delete(str, 1,index);
    if length(key) = 0 then
    begin
      key := noKey + IntToStr(noKeyIndex);
      inc(noKeyIndex);
    end;
    try
      ValueListEditor1.InsertRow(key, str, true);
    except
     on exception do ;
    end;
  end;
  CloseFile(Fp);
  result := true;
end;

//-----------------------------------------------------------------------------
function TfrmMain.SaveGrid(filename:string) : boolean;
var
  Fp : TextFile ;
  str : AnsiString;
  index, pos : integer;
begin
  AssignFile(Fp, filename);
  Rewrite(Fp);
  index := 0;
  while index <> ValueListEditor1.Strings.Count do
  begin
    if index > 0 then
      Writeln(Fp);
    str := IntToStr(index+1) + ',' + ValueListEditor1.Strings[index];
    pos := AnsiPos('=', str);
    str[pos] := ',';
    Write(Fp, str);
    inc(index);
  end;
  CloseFile(Fp);
  result := true;
end;

//-----------------------------------------------------------------------------
procedure TfrmMain.btnCreateClick(Sender: TObject);
var
  buffer : pChar;
  OutputFilename : pChar;
  InputFilename : pChar;
  Key : pChar;
  Save_Cursor : TCursor;
begin
  Save_Cursor := Screen.Cursor;
  OutputFilename := NIL;
  InputFilename := NIL;
  try
    Screen.Cursor := crHourGlass;    { Show hourglass cursor }
    if CurrentFilename <> '' then
      SaveGrid(CurrentFilename)
    else
      while CurrentFilename = '' do
        mnuSaveClick(Sender);

    if RadioButtonUser.Checked then
    begin
      if Length(EditKey.Text) <>  16 then
      begin
        MessageDlg('Please enter a key consisting of 16 bytes.',  mtInformation, [mbOk], 0);
        exit;
      end;
      Key := AllocMem(17);
      strPCopy(Key,EditKey.Text)
    end
    else
      Key := nil;

    InputFilename := AllocMem(Length(CurrentFilename)+1);
    OutputFilename := AllocMem(Length(CurrentFilename)+8); // worst case could be file wihout ext
    StrPCopy(InputFilename, CurrentFilename);
    StrPCopy(OutputFilename, ChangeFileExt(CurrentFilename, '.extres'));

    if mnuCreateCheader.Checked then
      ExportCDefs;
    if mnuCreateDelphiUnit.Checked then
      ExportPasDefs;

    if _extResCreate(InputFilename, OutputFilename, Key, CheckBoxCompress.Checked) <> 1 then
    begin
      buffer := AllocMem(256);
      _extResLastError(buffer, 256);
      MessageDlg('Error creating ExtRes file : ' + buffer,  mtInformation, [mbOk], 0);
      FreeMem(buffer);
    end
    else
      MessageDlg('Extres file successfully created.',  mtInformation, [mbOk], 0);
  finally
    Screen.Cursor := Save_Cursor;  { Always restore to normal }
  end;
  if(Key <> nil)then
    FreeMem(Key);
  FreeMem(InputFilename);
  FreeMem(OutputFilename);
end;

//-----------------------------------------------------------------------------
procedure TfrmMain.ExportCDefs;
var
  Fp : TextFile ;
  index :integer;
begin
  AssignFile(Fp, ChangeFileExt(CurrentFilename, '.h'));
  Rewrite(Fp);

  Writeln(Fp, '/* extRes Creator 1.0 generated file */');
  Writeln(Fp, '/* C/C++ key constants for file ', ChangeFileExt(ExtractFileName(CurrentFilename), '.extres'), ' */');

  index := 0;
  while index <> ValueListEditor1.Strings.Count do
  begin
    Write (Fp, '#define ');
    Write (Fp, Copy(ValueListEditor1.Strings[index], 1, Pos('=', ValueListEditor1.Strings[index])-1));
    Write (Fp, '  ');
    Writeln(Fp, IntToStr(index+1));
    inc(index);
  end;
  CloseFile(Fp);
end;

//-----------------------------------------------------------------------------
procedure TfrmMain.ExportPasDefs;
var
  Fp : TextFile ;
  index :integer;
begin
  AssignFile(Fp, ChangeFileExt(CurrentFilename, '.pas'));
  Rewrite(Fp);

  Writeln(Fp, 'unit ',ChangeFileExt(ExtractFileName(CurrentFilename), ''), ';');
  Writeln(Fp, '(* extRes Creator 1.0 generated file *)');
  Writeln(Fp, '(* Deplhi key constants for file ', ChangeFileExt(ExtractFileName(CurrentFilename), '.extres'), ' *)');
  Writeln(Fp);
  Writeln(Fp, 'interface');
  Writeln(Fp, 'const');

  index := 0;
  while index <> ValueListEditor1.Strings.Count do
  begin
    Write (Fp, '  ', Copy(ValueListEditor1.Strings[index], 1, Pos('=', ValueListEditor1.Strings[index])-1));
    Write (Fp, ' = ');
    Writeln(Fp, IntToStr(index+1), ';');
    inc(index);
  end;
  Writeln(Fp, 'implementation');
  Writeln(Fp, 'end.');
  CloseFile(Fp);
end;

//-----------------------------------------------------------------------------
procedure TfrmMain.EditKeyExit(Sender: TObject);
begin
  if RadioButtonStandard.Focused then  // Key does not matter if user clicked on Standard radiobutton
    exit;
  if Length(EditKey.Text) <>  16 then
  begin
    MessageDlg('Please enter a key consisting of 16 bytes.',  mtInformation, [mbOk], 0);
    EditKey.SetFocus;
  end;
end;

end.








