#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include "..\..\extres.h"

int main(int argc, char *argv[])
{
  // Create resource file from sample1.extsrc file with custom key and compression
  int result = extResCreate("sample1.extsrc","sample1.extres","@34FrGt55^hYuiui", true);
  if(result == 0)
  {
    char buffer[256];
    extResLastError(buffer, 255);
    printf("error during creation of extres file : %s", buffer);
    return 0;
  }
  HANDLE extResHandle = extResLoad("sample1.extres");             // Load resource file
  if(extResHandle == 0)
  {
    char buffer[256];
    extResLastError(buffer, 255);
    printf("error during opening of extres file : %s", buffer);
    return 0;
  }
  result = extResSetKey(extResHandle, "@34FrGt55^hYuiui");        // Set custom Key
  if(result == 0)
  {
    char buffer[256];
    extResLastError(buffer, 255);
    printf("error during setting of key : %s", buffer);
    return 0;
  }
  
  for(int i =0; i < 100; i++)                                     // print the first 100 resources(if available)
  {
    long size;
    LPSTR str = extResGet(extResHandle, i, &size);                // Get resource
    if(size > 0)
    {
      printf("\n\nResource %d : %s\n",i, str);
      extResFree(str);                                            // Free resource
    }
  }
  
  result = extResUnload(extResHandle);                            // Unload resource file
  if(result == 0)
  {
    char buffer[256];
    extResLastError(buffer, 255);
    printf("error during unloading of extres file : %s", buffer);
    return 0;
  }
}